#!/bin/bash

#in: block_unsigned/*.blk
#out: block_signed/*.blk
#encadena bloques mediante el hash previo
#encuentra el hash que cumpla las condiciones de dificultad

NONCE=0
HASH=0
VALOR=0
PRE=1
COUNT=0
BLOCKU=0 #PRIMER bloque sin firmar

RAND=( $(shuf -i 0-9999 ) )

DBU=./block_unsigned
BLOCKS=./block_signed

FILE=$(grep BUFFER mbiot.conf)
BUFFER=${FILE##*=}

BUCLES=$[ $(ls $DBU | wc -l) - $(ls $BLOCKS | wc -l) - $BUFFER ]

while true;
do
	echo "Buscando bloques para PoW"
	BLOCKU=$(diff -q $DBU/ $BLOCKS/ | grep : | head -n 1 | cut -d " " -f 4)
	BUCLES=$[ $(ls $DBU | wc -l) - $(ls $BLOCKS | wc -l) - $BUFFER ]
	
	echo "bucles: "$BUCLES
	
	if [[ $BUCLES -lt 1 ]];then
		echo "BUFFERING"
		echo "esperando 1m"
		sleep 1m
		continue
	
	#COMPROBACIN DE BLOCKES SIN MINAR

	elif [[ ! $BLOCKU ]];then
		echo "No hay bloques PoW pendientes"
		echo "esperando 1m"
		sleep 1m
		continue
	else
		
		#HASH PREVIO
		FPB=$(ls $BLOCKS | tail -n 1)
		echo "FPB: "$FPB

		#cp $DBU/$BLOCKU $BLOCKS

		if [[ $FPB ]]; then
			echo "hay hash previo"
			FILE=$(tail -n 1 $BLOCKS/$FPB)
			echo "FILE: "$FILE
			HPRE=$FILE
			#echo $HPRE >> $BLOCKS/$BLOCKU
			echo $HPRE >> $DBU/$BLOCKU
		else
			HPRE=0
			#echo $HPRE >> $BLOCKS/$BLOCKU
			echo $HPRE >> $DBU/$BLOCKU
			echo "no hay hash previo"
		fi
		echo "hpre: "$HPRE

		echo "inicio bucle hash"
		echo "PRE: "$PRE
		while true;
		do
		
			#CALCULO HASH
			
			
			VALOR=$(echo $(cat $DBU/$BLOCKU)$NONCE)
			
			HASH=$(echo $VALOR | sha256sum)
			PRE=$(echo ${HASH:0:2})
			
			echo "BLOQUE: "$BLOCKU
			echo "VALOR: "$VALOR
			echo "PRE: "$PRE
			echo "NONCE: "$NONCE
			echo "HASH: "$HASH
		
			if [ $PRE = "00" ]; then
				echo "---------"
				echo $NONCE
				echo $NONCE >> $DBU/$BLOCKU
				echo $HASH 
				echo $HASH >> $DBU/$BLOCKU
				cp $DBU/$BLOCKU $BLOCKS
				RAND=( $(shuf -i 0-9999 ) )
				COUNT=0
				break
			else
				echo "nonce invalido: "$NONCE
				echo $HASH
				echo "iteracion: "$COUNT
				if [ $COUNT -gt 9999 ]; then
					break
				else
					let COUNT=COUNT+1
					NONCE=${RAND[$COUNT]}
				fi
				echo "---------"
			fi
		done
	fi

	echo $HASH
	echo nonce: $NONCE

done
