#!/bin/bash

#MAIN
#Contiene la logica del programa

#configuración
FILE=$(grep NODE mbiot.conf)
#echo $FILE
NODE_TYPE=${FILE##*=}
NODO=$(echo ${NODE_TYPE,,}) # | tr '[:upper:]' '[:lower:]'

echo "================="
echo "==    MBiOT    =="
echo "================="
echo "Tipo de nodo: "$NODO



echo "Iniciando MBiOT"
echo "Comprobación inicial"

if [  -d  "./block_signed" ] ; then
	echo "comprobando block_signed"
else
	echo "creando block_signed"
	mkdir block_signed
fi

if [  -d  "./block_unsigned" ] ; then
	echo "comprobando block_unsigned"
else
	echo "creando block_signed"
	mkdir block_unsigned
fi

if [  -f  *.id ]; then
	echo "comprobando id"
else
	./genid.sh
	cd NA1/ && . ../genid.sh
	cd ../NA2/ && . ../genid.sh
	cd ../NA3/ && . ../genid.sh
	cd ..
fi

if [  -d  $(cat *.id) ]  && [ $NODE_TYPE == "master" ] ; then
	echo "comprobando id"
else
	echo "creando id"
	mkdir $(cat *.id)
fi

if [ ! -d  "./keys" ] && [ $NODE_TYPE == "master" ] ; then
	echo "creando keys"
	mkdir keys
	./keygen.sh
else
	echo "comprobando keys"
fi

if [ ! -d  "./data" ] && [ $NODE_TYPE == "master" ] ; then
	mkdir data
else
	echo "comprobando data"
fi

while true;
do
	echo "ejecutando catcher"
	./catcher.sh
	echo "ejecutando blocker"
	./blocker.sh
	echo "pausando 5s"
	sleep 5
done

