#!/bin/bash
source ./lib/hasher.sh
source ./lib/chainer.sh
source ./lib/restorer.sh

#comprueba el encadenamiento de los bloques
#crea backup cuando es correcta

BLOCKS=./block_signed
LEDGER=./ledger
LFILE=""

while true;
	do
	chainer $BLOCKS $LEDGER
	if [ $? -eq 0 ]; then
		echo "slave chainer bien"
	else
		echo "slave chainer mal, no se ha podido recuperar"
		#FILE=$?
		#restorer $BLOCKS/$FILE $LEDGER/$FILE
	fi


	#si el hash del bloque est bien se introduce en el ledger
	for x in $(ls $BLOCKS/*.blk);
	do
		
		LFILE=$(echo $x | cut -d "/" -f 3)
		echo "nonce signer: " $(head -n 8 $x | tail -n 1)
		echo "nonce ledger: " $(head -n 8 $x | tail -n 1)
		
		hasher $x
		if [ $? -eq 0 ]; then
			echo "slave hasher bien: " $x
			mkdir -p $LEDGER
			diff -q -N $x $LEDGER/$LFILE > /dev/null
			if [ $? -eq 0 ]; then
				continue
			elif [ ! -e $LEDGER/$LFILE ]; then
				cp $x $LEDGER/
			elif [ $? -eq 1 ] && [ $(head -n 8 $x | tail -n 1) -gt $(head -n 8 $LEDGER/$LFILE | tail -n 1) ]; then
				cp $x $LEDGER/		
			elif [ $? -eq 1 ] && [ $(head -n 8 $x | tail -n 1) -lt $(head -n 8 $LEDGER/$LFILE | tail -n 1) ]; then
				echo "el nuevo bloque tiene un nonce menor"
			else
				echo "error"
			fi
		
		
		else
			echo "slave: intento recuperar en hash"
			echo "restorer: "$x " " $LEDGER/$LFILE
			restorer $x $LEDGER/$LFILE
		fi
	done

	./jsoner.sh
	echo "estado ok"
	echo "esperando 1m"
	sleep 1m
done

#hasher $1
